.functions:
  script: |
    #? Loading ci/scripts/.functions:script
    colorize() {
      export RED="\033[31m"
      export GREEN="\033[92m"
      export VIVID="\033[95m"
      export RST="\033[0m"
    }
    colorize

    log_info() {
      echo -e "${GREEN}[INFO]: $1${RST}"
    }

    log_warning() {
      echo -e "${YELLOW}[WARNING]: $1${RST}"
    }

    log_error() {
      echo -e "${RED}[ERROR]: $1${RST}"
    }

    log_fatal() {
      echo -e "${RED}[FATAL]: $1${RST}"
      return 1
    }

    log_section() {
      echo -e "section_start:$(date +%s):section_$(date +%s)\r\e[0K${VIVID}$1${RST}"
    }

    check_variables_defined() {
      for var in "$@"; do
        if [ -z "$(eval "echo \$$var")" ]; then
          log_fatal "${var} not defined";
        fi
      done
    }

    install_requirements() {
      log_section "Installing requirements..."
      case $(cat /etc/*-release | grep 'PRETTY_NAME') in
        *Alpine*)
          log_info "Alpine detected"
          apk add --no-cache "$@"
          ;;
        *Ubuntu*)
          log_info "Ubuntu detected"
          apt-get update && apt-get install -y "$@"
          ;;
        *Debian*)
          log_info "Debian detected"
          apt-get update && apt-get install -y "$@"
          ;;
        *Centos*)
          log_info "Centos detected"
          yum install -y "$@"
          ;;
        *)
          log_fatal "Cannot install. I am not sure what OS this is"
          ;;
      esac
    }

    semrel_tag() {
      tag="$1"
      regex='(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)(?:-((?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*)(?:\.(?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*))*))?(?:\+([0-9a-zA-Z-]+(?:\.[0-9a-zA-Z-]+)*))?'
      install_requirements grep > /dev/null 2>&1
      tag=$(echo "$tag" | grep -Po "${regex}")
      echo "${tag}"
    }
